package com.garrettwu.joji.exec;

import com.garrettwu.joji.JojiGame;
import com.garrettwu.joji.controller.JojiController;
import com.garrettwu.joji.model.JojiModel;
import com.garrettwu.joji.util.JojiClock;
import com.garrettwu.joji.view.JojiView;

/**
 * This default executor runs the game in the current thread.
 *
 * <p>Calling the <code>execute</code> method will block until the game has completed.</p>
 */
public class JojiDefaultExecutor<
    M extends JojiModel,
    V extends JojiView<? super M, ? super C>,
    C extends JojiController<? super M>> implements JojiExecutor<M, V, C> {
  /** {@inheritDoc} */
  @Override
  public void execute(JojiGame<M, V, C> game, JojiClock clock) {
    new JojiMainLoop<M, V, C>(game, clock).run();
  }
}
